#include <stdio.h>
#include <string.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int command_callback_cast_spell(char *line);
void callback_invoke_projected_circle(void);
void callback_sendback_great_old_one(void);
void callback_remove_water(void);

int area_temple(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
			message("ϲζƶ˺줿Ť¤Τ褦"
					"Ϥɤ˱äơ"
					"桼åɴŪʳ줬Ω¤Ǥꡢ"
//					"Ϥ轻̱ΰפȤϻƤĤ̡"
					"Ūʶ֤äƤ롣");
			message("¦ɤˤϡ%nl餷ΤƤ롣",
					ni_passage);
			if (Is(temple_unsunken)){
				message("ظƤޤϲƻĤƤ롣");
				message("ˤϡ̾¸%nw򲼤Ƥ롣",
						 ni_it);
			}
			else {
				message("ظˤϡϲؤ³ϩ롣");
				message("ϴ˿פƤꡢ"
				       "ˤϵʤʤˤ%nw⤫Ǥ롣",
					   ni_it);
			}
            return 1;
		case vi_forward:
			if (Not(temple_unsunken)){
				message("ϿפƤꡢޤǤɤ失ʤ");
			}
			if (Not(temple_burning)){
				message("꤬ԤɤǤ롣");
			}
			else {
				message("ʤϼ̤ߤȡ"
						"Ӥ춸ȿߤ褦ˤ"
						"¤ȴ"
						"%nnؤӹ",
						ni_passage);
				move_area(ai_cave);
			}
			return 1;
		case vi_backward:
		case vi_exit:
			if (Is(great_old_one_gone)){
				message("ɤơ褿ƻɤǤޤäƤ롣");
			}
			else {
	            move_area(ai_corridor_0f);
			}
            return 1;
        case vi_cast:
            message("Ⱦ?");
            set_command_callback(command_callback_cast_spell);
            set_console_prompt(QUERY_PROMPT);
            return 1;
        default:
            break;
        }
        break;
    case ni_spell:
        if (vid == vi_cast){
            RedoArea(vi_cast, ni_invalid);
        }
        break;
	case ni_lantern:
		if (!has_item(nid)) ReturnNotExist;
		switch (vid){
		case vi_throw:
			message("󥿥פڤ󤯤ꤲȡ"
					"ޤ˰Фǳä");
			message("ϱ꤫ƨ褦ȿ夲"
					"㤷夨äƤ롣");
			Set(temple_burning);
            lose_item(ni_lantern);
			return 1;
		default:
			break;
		}
		break;
	case ni_it:
		switch (vid){
		case vi_look:
		case vi_examine:
			message("ˤϡ"
					"Ūˤͤ%nlΤ褦ʤΤ"
                    "Ĥ⤫Ӿ夬ꡢ"
					"ޤ%nlӤƤ롣",
					ni_face, ni_tentacle
					);
			if (Not(great_old_one_gone)){
				message("Ϥä̮ǤʤƤ롣");
			}
			else if (Not(temple_burning)){
				message("ΤʤäΤ褦˹Ӥ춸äƤ롣");
			}
			else {
				message("ϱ˾Ƥ졢ζ٤򸫤Ƥ롣");
			}
			return 1;
		default:
			break;
		}
		break;
	case ni_face:
		switch (vid){
		case vi_look:
		case vi_examine:
			if (Not(great_old_one_gone)){
				message("ɤδɽ򤷤Ƥ뤬"
						"¤ѻʹ֤Τ褦ʴǡ"
						"ʤ򸫤ĤƤ롣");
			}
			else {
				message("䶫뤫Τ褦礭򳫤Ƥ롣"
						"礭Ƥ뤬ǤοϤʤ");
			}
			return 1;
		default:
			break;
		}
		break;
	case ni_tentacle:
		switch (vid){
		case vi_look:
		case vi_examine:
			if (Not(great_old_one_gone)){
				message("ϲϤ⤦Ȥ뤫Τ褦ˡ"
                        "ŷؤȿФƤ롣\\"
						);
			}
			else {
				message("㤷󤵤Ƥ롣\\");
			}
            message("ܤϽդǤ졢"
                    "ޤ路αդήФƤ롣");
			return 1;
		default:
			break;
		}
		break;
	case ni_passage:
		switch (vid){
		case vi_look:
		case vi_examine:
			message("ؤ³Ƥ褦"
					"ǤϤ褯ʤ");
			return 1;
		case vi_enter:
			RedoArea(vi_forward, ni_invalid);
			return 1;
		default:
			break;
		}
		break;
    case ni_floor:
		if (Not(great_old_one_gone)){
			message("ϴ˿פƤ롣");
			return 1;
		}
		switch (vid){
		case vi_look:
		case vi_examine:
			message("夬ˤϡФξƤ롣");
			message("ˤ%nl򲼤"
					"¦ˤɤϩؤ³ʤ롣",
					ni_it);
			message("¦ϵޤʼ̤ˤʤäƤꡢ"
					"ʤȤޤǹߤ줽");
			if (Is(temple_ceiling_destroyed)){
				message("%nnμˤϡɥ̤ήФ"
						"󤬹äƤ롣",
						ni_it);
			}
			return 1;
		default:
			break;
		}
        return 1;
    case ni_wall:
    case ni_ceiling:
		if (Is(magic_circle_invoked) && Is(cycrotron_activated)){
			message("ƶŷδȩˤϡˡؤ⤫Ӿ夬äƤ롣");
		}
		else {
			message("οѤǺ줿Τ"
					"¤η߼ԤˤΤ狼ʤ"
					"ɡŷˤʤäƤ롣");
		}
        return 1;
    default:
        *exist = 0;
        break;
    }
    return 0;
}


int command_callback_cast_spell(char *line){

    strip_space(line);
    /*
    message(" \\");
    message(SPELL);
    message(line);
    */
    // ʸäʤˤⵯʤ
#ifdef DEBUG
    if (strcmp(line, DEBUG_SPELL) != 0 && strcmp(line, SPELL) != 0){
#else 
    if (strcmp(line, SPELL) != 0){
#endif
        msg_no_effect();
        return 0;
    }
    message("ʤʸ򾧤ϤȡΤϡ"
            "鷺ˤ˸");
    //    Set(temple_spell_cast);
    //    message("ɽƤ饦%w");
    //    message("äȤɽƤ饦%w");
    //    message("⤦äȥåɽ");
    //    set_command_callback(command_callback_sendback_great_old_one);
    // ƿؤưƤʤвⵯʤ
    if (Not(magic_circle_invoked) || Not(cycrotron_activated)){
        message("\\");
        msg_no_effect();
        return 0;
    }
    // Ȥꤢʸ̤ȯϤ
    message("ʤθդȶˡŷˡؤ굱"
            "⤬ϤƤΤ򴶤롣");
    set_wait_return_callback(callback_invoke_projected_circle);
    // ʸreturn_callback桢ץץȤʤ褦
    // command_callback³˸
    // command_callbackreturn_callback򽪤Ȥ˼ưǥꥢ
    return 1;
}
void callback_invoke_projected_circle(void){
    if (HasNot(amulet)){
        message("\n"
                "ʸ򾧤Ʊ˸Ͼä"
                "ƤϤ⤽Τޤ޵äƤä");
        // ޥɥХå³˸ƤΤǼưǥꥢ
        clear_command_callback();
        return;
    }
    message("\n"
            "ʸ򾧤Ʊˡˡؤ줿«"
            "ΤӤ"
            "򿶤󤷤夨ޤ路椫顢"
            "Ф褦ˤƵʰ۷αƤ롣"
            "«ϱƤ«褦ߤĤȡˡؤذ󤻤Ƥä");
    set_wait_return_callback(callback_sendback_great_old_one);
}
void callback_sendback_great_old_one(void){
    message("\n"
            "ŪʻѤαƤ⤬ʤˡؤ˻Ѥäȡ"
            "ˡؤ򼺤äƤä"
            "ˤϡۼԤȴ̤Ȥʤä̾Ĥ줿");
    Set(great_old_one_gone);
    set_wait_return_callback(callback_remove_water);
}
void callback_remove_water(void){
    message("\n"
            "٤ƤäȻפäȤ"
            "Ĥ줿ä褦ˤ⤬Ϥ᤿"
            "꤬ɤáĤ졢"
            "̯ʷ򤷤줬դ롣"
			"1ܤʤ򽱤ΤΡ"
			"㪤ˤäƻɤƤޤä");
    message("դȡɤ˵äΤίޤäƤ夬ήФ"
            "¤ξѤ򸽤Ƥ");
    Set(temple_unsunken);
    // ޥɥХå³˸ƤΤǼưǥꥢ
    clear_command_callback();
}

void post_temple(int time_passed){
	if (!time_passed) return;
    if (Is(temple_unsunken) && Not(temple_ceiling_destroyed)){
		message("\n"
				"˽춸˴٤ǤΤᤵ졢"
				"Ĥŷ椬");
		message("㪤ȶƤ֤ˤ֤Ĥꡢ"
                "ޤ餷ʤ龲ξžä"
                "ѤޤƤɥ̤ΤĤ٤졢"
                "ξ˹äƤ");
                //				"٤줿ɥ̤ήФ"
                //				"äƾξ˹ä");
		Set(temple_ceiling_destroyed);
	}
}

#if 0
}
#endif
