#ifndef CONSOLE_H
#define CONSOLE_H
#include "status.h"

#ifdef CODE_SJIS
#define Is2bChr1(c) (((unsigned char)(c) >= 0x81 && (unsigned char )(c) <= 0x9f) || ((unsigned char)(c) >= 0xe0 && (unsigned char)(c) <= 0xfc))
#endif
#ifdef CODE_EUC
#define Is2bChr1(c) ((unsigned char)(c) >= 0xa1 && (unsigned char)(c) <= 0xfe)
#endif

#define DEFAULT_PROMPT ">"
#define QUERY_PROMPT "?"
#define PROMPT_LEN 1

#define NOTAIL_2B_MARKS "ʡ֡"
#define NOHEAD_2B_MARKS "ˡס١"
#define NOHEAD_2B_KANA  "ä"

void init_console(void);
void clear_console(void);
void clear_input_line(void);
void erase_cursor(void);
void append_input_line(char *str);
void console_key_releaseh(int key);
void console_keyh(int key);
void put_console(char *line);
void draw_console(void);
void set_console_input(input_mode_t mode);
void set_console_prompt(char *prompt);
void set_wait_return_callback(void (*callback)(void));
void wait_return_keyh(int key);
void strip_space(char *line);
#endif





