#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include "config.h"
#include "message.h"
#include "layout.h"
#include "console.h"
#include "command.h"
#include "verb.h"

static char rest_message[MESSAGE_MAX_LEN];
static int rest_message_len;
static int is_callback;
static int is_callback_set;

void message(char *msg, ...){
    va_list ap;
    char buf[MESSAGE_MAX_LEN];
    char *msgp = msg, *bufp = buf, *p;
    int n;
    noun_id_t nid;
    verb_id_t vid;
    //    char *wait_break = "!\0";
    char *rest_msg = NULL;

	va_start(ap, msg);
    while (*msgp != '\0'){
        if (Is2bChr1(*msgp)){
            *bufp++ = *msgp++;
            *bufp++ = *msgp++;
        }
        else if (*msgp == '%'){
            msgp ++;
            switch(*msgp){
            case 's':
                p = va_arg(ap, char *);
                strcpy(bufp, p);
                bufp += strlen(p);
                break;
            case 'd':
                n = va_arg(ap, int);
                bufp += sprintf(bufp, "%d", n);
                break;
            // idǻꤷ̾ɽ
            case 'n':
                nid = va_arg(ap, noun_id_t);
                msgp ++;
                switch(*msgp){
                // ̾̾Ρñɽ
                case 'l':
                    p = noun_name(nid);
                    strcpy(bufp, p);
                    bufp += strlen(p);
                    *bufp++ = '[';
                    p = nid2noun(nid);
                    strcpy(bufp, p);
                    bufp += strlen(p);
                    *bufp++ = ']';
                    break;
                // ̾̾Τɽ
                case 'n':
                    p = noun_name(nid);
                    strcpy(bufp, p);
                    bufp += strlen(p);
                    break;
                // ̾ñɽ
                case 'w':
                    *bufp++ = '[';
                    p = nid2noun(nid);
                    strcpy(bufp, p);
                    bufp += strlen(p);
                    *bufp++ = ']';
                    break;
                default:
                    printf("%%n%c is not supported in message().", *msgp);
                    exit(1);
                }
                break;
            case 'v':
                vid = va_arg(ap, verb_id_t); 
                p = vid2verb(vid);
                printf("hoge:%d:%s:\n", vid, p);
                strcpy(bufp, p);
                bufp += strlen(p);
                break;
			// ΰ֤ǥåϤǤ꥿󥭡Ԥ򤹤
            case 'w':
				if (is_callback){
					// Хåĺǽ%w
					if (rest_msg == NULL){
						// ޤǤʬϤϥХåե
					    *bufp = '\0';
						put_console(buf);
						bufp = buf;
						rest_msg = msgp+1;
					}
					else {
						// 2ܰʹߤ%wϤΤޤ޻Ĥ
						*bufp = '%';
						*(bufp+1) = 'w';
						bufp += 2;
					}
				}
				// ХåǤʤ
				else {
					// åίޤäƤʤ
					if ((rest_msg == NULL) && (is_callback_set == 0)){
						// ޤǤʬϤϥХåե
					    *bufp = '\0';
						put_console(buf);
						bufp = buf;
						rest_msg = msgp+1;
					}
					else {
						// åίޤäƤʤ餳ξǽϤǤʤΤ
						// %wϤΤޤ޻Ĥ
						*bufp = '%';
						*(bufp+1) = 'w';
						bufp += 2;
					}
				}
/*
				// äåǽ%wʤ
				if (rest_msg == NULL){
				}

                rest_msg = msgp+1;
                msgp = wait_break;
				*/
                break;
            default:
                printf("%%%c is not supported in message().", *msgp);
                exit(1);
            }
            msgp ++;
        }
        else {
            *bufp++ = *msgp++;
        }
    }
    *bufp = '\0';
    va_end(ap);

    if ((rest_msg != NULL) || (!is_callback && is_callback_set > 0)){
        set_rest_message(buf);
        printf("set wait return callback:%s:%s\n", buf, rest_message);
        set_wait_return_callback(message_rest);
		is_callback_set = 1;
    }
	else {
		rest_message_len = 0;
		put_console(buf);
	}
}
void set_rest_message(char *rest){
	if (is_callback){
	    strcpy(rest_message, rest);
		rest_message_len = strlen(rest_message);
	}
	else {
        // Хåե˥åĤäƤꡢ%wǽäƤʤ
        // message()ɲä줿åȤδ֤˲Ԥ򶴤Ǥ
        if (rest_message_len > 0){
            if (*(rest_message + rest_message_len-2) != '%' ||
                *(rest_message + rest_message_len-1) != 'w')
            {
                *(rest_message + rest_message_len) = '\n';
                rest_message_len ++;
            }
        }
        strcpy(rest_message + rest_message_len, rest);
        rest_message_len += strlen(rest);
	}
}
void message_rest(void){
	is_callback = 1;
	is_callback_set = 0;
    message(rest_message);
	is_callback = 0;
}


Msg(cannot_do, "ǤϤǤʤ");
Msg(cannot_destroy, "Τ̵");
Msg(cannot_read, "ɤʤ");
Msg(cannot_move, "ӤȤ⤷ʤ");
Msg(cannot_climb, "褸ФΤ̵");
Msg(no_effect, "ʤˤⵯʤä");
Msg(nothing_special, "ȤѤäȤϤʤ");
Msg(no_object, "ˤϸʤ");
Msg(nothing_any_more, "⤦ʤ");
Msg(need_to_get, "ޤϼ˼äƤߤۤ");
Msg(no_need_to_carry, "äƹԤɬפϤʤ");
Msg(which_door, "ʣ롣");
Msg(which_bookshelf, "êʣ롣");
Msg(door_locked, "ˤϸݤäƤ롣");
Msg(door_unlocked, MSG_DOOR_UNLOCKED);
Msg(door_already_unlocked, MSG_DOOR_ALREADY_UNLOCKED);
Msg(door_closed, "⤬ĤޤäƤ롣");
Msg(door_already_closed, "ϤǤĤޤäƤ롣");
Msg(door_unlocked_by_opening, "μü󤹤ȡȸ줿");
Msg(key_unmatched, "θϸ˹ʤ");
Msg(too_large, "äƤˤ礭롣");
Msg(too_heavy, "Ť롣");
Msg(too_far, "Ǥϱ󤹤롣");
Msg(combine_unmatched, "Ȥ߹碌ʤ");
Msg(bootstrap, "ʿǤΤϥߥҥϥ˼ߤ餤");
Msg(multiple_climb, "ʾɤФȤΤ");

void msg_armor_standing(void){
    message("ܤˤ%nnΩäƤ롣", ni_armor);
}
void msg_look_standing_armor(void){
    message("%nl򹽤ˤ⤢ʤ˻¤꤫ȤƤ롪",
            ni_sword);
}
Msg(look_standing_armor_sword, "ڤ̣ɤ");
Msg(no_magic_circle, "⤦ˡؤϻĤäƤʤ");
Msg(blocked_by_furniture, "¤ȶ񤬼ǶŤʤ");
Msg(no_space_to_move, "ư꤬ʤ");


void msg_to_start(void){
    message("%v(ǽ餫)ޤ"
			"%v(³)ϤƤ", vi_start, vi_load);
}
void msg_start(void){
    message("ʤϳդγξΩĸŤߤˤäƤ");
    message("ٹ뤬ƤȤǡʺ̲ȸƤ롣"
            "Ԥ꼡줿ۤȤƤͭ̾Ǥꡢ"
            "Ƕ̾ȤǤ륵纴ǹˤʤä"
            "ʹ󤸤줿Ф");
    message("긵ˤϿʹڤȴ%nw롣", ni_newspaper);
}

void msg_to_title(void){
    message("ȥʤ%vס"
            "ǡɤʤ%vפϤƤ",
            vi_title, vi_load);
}
void msg_read_newspaper(void){
    message("֡إ纴ͩߤǹ");
    message("ȤΥ纴"
            "εޥɥʥšĴ˽Фޤ"
            "äƤʤȤȽ"
            "Ʊš1930ǯ"
            "ٹλ᤬ʤܤΤ˷Ƥ"
            "׿»˻᤬Τڤ˹Ԥ꼡"
            "1995ǯΥ襷ζȼ϶ȤȤʤäƤ롣"
            "α"
            "äԤäƤʤ줿ߤȤơ"
            "ϸǤݤƤ");
}
void msg_look_newspaper(void){
       message("纴ι󤸤"
                //                "ֺǯơ%nlȶ鵢񤹤"
                "ֺǯβơȶ鵢񤷤"
                "ͥ纴פ"
                "ФΤĤ̿ˡ纴餷ʪ̤äƤ롣");
}
void msg_read_essay(void){
    message("֤ܤΤФ󡡡襷");
    message("ܤΤФϤ郎ޤޤǤ"
            "礭ʤäƤܤ̤ˤʤäȤ"
            "βȤˤäơΥ٥åɤ餤ޤ"
            "Ǥ⡢ޤǤʥ٥åɤΤ"
            "ФΤ礦Ȥäơ"
            "褯ܤɤߤˤޤ"
            "ܤȤܤޤ"
            "Τޤä̤ߤΤäݤǤ֤ޤ"
            "ܤȤ⤤ޤǤ䤵Ȥ⤢ޤ"
            "");
}
void msg_read_diary(void){
	message("κǸɤǤߤ");
    message("1222"
			"ޤ줿"
            "޽񼼤ä㤵êΤΤˤĤޤŤߤ"
			"㤬ڤä椷ʤƤ褫ä");
//essage("");
//essage("ǸΥڡɤǤߤ");
//    message("ʤˤ餷ƤΤǡ"
//            "鷺ҤäѤƤޤä");
    message("1223"
            "Ƕ褯Ѥ̴򸫤롣"
            "٥åɤǿƤȡ"
            "ϲ鲿ŤƤ褦ʡ"
            "ϥꥹޥ֡"
		    "ߤʤǳڤᤴȤ"
            "");
            message("ʹߤΥڡ");
}
void msg_examine_diary(void){
    message("ѤѤ᤯ȡˤ줿ڡä");
    message("107"
			"˾夬ꤳͷǤ"
			"̤ˤʤäƤʥ٥åɤϻΤΤäƸäƤΤˡ"
			"ޤˡ䤬ֵäƤʤΡ");
    message("μΥڡܤˤȤƤ롣");
}

void msg_read_diary_piece(void){
	message("֤äݤǤä顢"
			"פ鷺äѤƤޤä"
			"ˤϰȤ򤷤äޤʤ");
}
void msg_read_logbook(void){
    message("Ǹͤˤޥɥʥ׿ͤδǸϿ");
    message(
            //            "׿ͤϤʤŤ¤ǡ"
            //            "׿ͤϤβߤǰդαǤʤ򤷤Ƥ褦ǡ"
            "ǽκϤޤä餷ڼǥԥΤƤꡢ"
            "ƲפȿȤäꤹͤ񤫤Ƥ롣"
            "˿夬ʤߡ"
            "椫ϲڼ٤οǤۤȤɿȤʤäƤ롣"
            "ޥɥʥɻˤޤԤ"
            //            "դؽۤ"
            "Ťܽ褬ΩجäƤ餷"
            "ϿκǸǤϡʥȵƬ"
            "ǸͤҤɤ̣äƤ롣"
            );
            //            "׿ͤϤʤŤ¤ǡ˾ɾʹԤƤ褦"
}
void msg_read_postcard(void){
	message("֤ϸǤäƤ롣"
			"ꥪ"
			"(ʤߤ3ܤ"
			"ä2ܤϺǯŷ˾줿)"
			"ȰפõƤ衣");
    message("  μˤäޥɥʥšäϡ"
		    "ʽ롣"
			"ꤷߤ"
			"餬դޤǻ֤ꤽ"
			"ޤ̵򤻤ѤäȤФ˲ߤФۤ"
		);
}
void msg_read_sanders_note(void){
    message("֥å");
    message("ɤǤʤ顢"
            "οȤˤʤˤäȤȤ"
            "ϴ"
            "ȤȤϡ֤ѤǤ륬ȤäƤ졣");
    message("̵äϢ쵢äߤ"
            "̵ۤۤ̾Ƥ٤иȤʹ");
    //    message("");
    message("ˡ");
}
void msg_read_easy_necromancy(void){
	message("5ʬǤǤѡ٤Ȥ󤯤Ƥ񤫤Ƥ롣");
    msg_recall_easy_necromancy();
}
void msg_recall_easy_necromancy(void){
	message("ֽѼξˤϡԤۤο֤٤");
	message("Ԥȱοʤ򡢰Ȥۤ٤");
	message("ʪȿΤ٤");
}

void msg_read_yoshino_notebook(void){
	message("ۤȤɤΥڡˤϿޤ񤭻餵Ƥ뤬"
            "Ǹ˼국Τ褦ʤΤƤ롣");
	msg_recall_yoshino_notebook();
    message("국ϤǽäƤ롣");
}
void msg_recall_yoshino_notebook(void){
	message("ֿʹ֤Τ褦ʰդ¸ߤȤפʤ"
			"ۤäΤ褦ˡꥹޥ֤ͼ٤˻䤿ۤ褦Ȥ"
			"ʤȻҶΰռϤǤˤʤ"
			"ϤޤˤϻۤƤʤ"
			"ĤޤѤ뤫%w");
	message("\n"
			"ۤ˻ۤʤΤϡ"
			"ϲε뤿餷"
			"׹Ϥ򼺤äͷǤϡŻ̵ʤΤ"
			"ߤΤۤδƻδ㤬æФԲǽ"
			"ιͤư٤ƸƤ櫓Ǥʤ褦"
			"ʤȤۤ΢򤫤ʤΤ%w");
	message("\n"
			"޽񼼤õäơ"
			"鷺ʤޥɥʥɤĤ򸫤Ĥ"
			"ޥɥʥɤϥȥ󵡴ؤȸƤǤ뤬"
			"䤬Τ륵ȥȤϰۤʤ֤Τ褦"
			"ܺ٤ưϧǤꡢ"
			"ޥɥʥɤۤ򾤴ݡ"
			"۳򳫤ưϸˤ褦%w"
			);
	message("\n"
            "٤餻ʤäƤ"
            "ŪʵˤĤƤ糰ǤäѤ狼ʤ"
			"ʤȤ纴ƤС"
            "ϫΤἼζ˽λѤ򸫤Ƥޤ"
            "𤷤ƶáäƤޤä"
            "⤽ʤ褦%w"
            );

            //            "ؤܽ褬ĤˤĤƤϤäѤ狼ʤ"

            //			"ʤȤ򳫤ۤԤǤʤĴ٤Ƥ"
            //			"ˡ狼ʤ"
            //			"ؤν٤餻ʤ顢"
    //			""
    //			"ΰտޤ򵤤Ť줿⤷ʤ"
    //			""
    //			""
    message("\n"
            "ۤˤΰտޤ򱣤Τ³"
            "ؤνˡϡۤܤ˿ʤȤ˽񤤤Ƥ"
            "ʬμǷĤä̵ǰ"
            "⤦ٳǿϤळȤǤʤ顢ϡ");
}
/*
			"ܺ٤ʤȤưӤϤĤ%w"
ο¬̤ꡢȥ󵡴ؤ򳫤ȤǤʤ顢
ۤŪϲ⤷䡢֤򤳤˸ƤӴ󤻤ĤʤΤǤϡ
ʤȤԤεԤʤĴ٤Ƥ
ɬפʤΤ·Τ񤷤
ʤȤ纴ƤС
ۤѤʤ褦ؤϸξ㤵Ƥ롣
ˡϲߤ˱Ƥ
"ۤ˻ۤʤΤϡ"
			"Ф餯ϼʬݤäޤư뤳ȤǤ"
			"ۼȤϺ٤ȤǤΤäƤʤ"
			"ޤǻۤ줿Ԥϻ׹Ϥ򼺤褦顢"
			"μλŻ򤵤Τ̵ʤΤ"			
"ɤˤȥ󵡴ؤưӤĤ"
ϰưϧǡ۳ؤ򳫤ͥ륮뤿˻Ȥä褦"
ȤСۤ򸵤ξԤǤΤǤϤʤ"
	message("񤭤ϤǽäƤ롣");
    message(
            "ۤ¤ꡢ夳βߤƧ߹ԤޤۤΤΤȤʤ"
            "ɤʪ⤹ǤۤƨʤʤäƤϤ"
            "ߤΤɤˡۤ򾤴ˡؤϤ"
			"ˡ");
    message("ֻ䤬줿Ťοΰ֤С"
            "ۤ뤳ȤǤϤ"
            "ˡؤ򸫤ĤƤ顢μǤĤΤ̵ǰ"
            );
*/

void msg_read_bathroom_wall(void){
//    message("ֻ⤳ޤǤΤ褦"
//            "ۤ˸Ĥʤ褦ˡ˥åĤ");
	message("ۤλϤޤäƤ"
			"Ϥ䤳ޤǤΤ褦");
	message("䤬ȥ󵡴ؤư򤷤Ȥ"
			"ۤŤΤǤС"
			"ޤ޻ۤ櫓ˤ⤤ޤ"
			"ޥɥʥɤؤΥͥ륮ǰ۳򳫤ΤǤС"
			"֤ۤƤӴ󤻤뤳Ȥǽ"
			"Υͥ륮ۤԤ뤳ȤǤϤ"
			"ؤǳϡ");
//			"Ԥεμ礵狼С"
//			"Υͥ륮ǤĤ򸵤ξԤ뤳Ȥ"
//			"ǽʤϤ"
//			);
//	message("ȥ󵡴ؤΡ");
    message("åϤڤƤ롣");
}
void msg_read_mirror(void){
	message("ֽʬ˻ĤäƤ뤬"
			"ޤȤƥ륷ɬפ롣"
			"¿Խʪʤϧȿˤϱƶʤ顢"
			"륷ޤǤФʤǤ褤");
//	message("ۤ˵ؤѤʤ褦"
	message("ˤۤѤʤ褦"
            "Υ֥ϥ硼ȤƤ롣"
			"֥֤路ƤФλưܥ򲡤С"
			"ʤưϤ");
}
void msg_read_mcdonald_notebook(void){
	msg_recall_mcdonald_notebook();
    message("국ϤǽäƤ롣");
}
void msg_recall_mcdonald_notebook(void){

    message("ֻ¤줿ʤߤȤϤ"
            "ѤäΤǤä");
    message("줿ΤϤä"
            "Ȱؤˡ˾ߤ𤨤Ƥȡ"
            "Ȥפʤä¤鷺"
            "غʤ̿ߤäƤдۤΤΤϤ٤Ƥ٤ȡ"
            "줬٤Ƥδְ㤤ä%w");
    message("\n"
            "ʤΤʤ⻺ˤϤʤä"
            "ѤˤۤϡۤμԤ⤹٤ƼʬΤΤȤΤ"
            "ѿͤʤ⡢ƻ⡣"
            "ۤϤ˺ʤफߤäƤ줿"
            "ΤϤϤۤΰ˲᤮ʤ"
            "ѤǼ줿Фִ֡"
            "ޤۤβ̤ͤƤ%w");
            //            "ˡؤ˼줿ΤȤäˤƨˤϡ"
            //            "꤬Фʤ褦%w");
            //            "ˡؤ˼줿Τƨˤϼ꤬Фʤ褦"
            //            "Фִ֡ޤۤβ̤ͤƤ%w");
    message("\n"
            "ǤϡۤѴȲѿͤ"
            "޾Ф뤫Τ褦ưäƤ롣"
            "伫Ȥˤۤλۤڤְʾ塢"
            //            "Фִ֡ޤۤβ̤ͤƤ"
            "˰Ĥ˾ߤʤ餬󤶤ΤԤ"
            "ߤæФޤ뤷ʤ");
    message("䡢ʡβϤʤ⤬⤬%w");
    message("\n"
            "ɤɤ줿褦"
            "ϤФ뤳Ȥ⤫ʤޤ"
            "ȤʤäƤϡĤ줿֤˾Ǥ뤢ޤꡢ"
            "ԤɬפʵΰǤ̤ޤ"
            "򶯹ԤȤޤ롣"
            "勞ϡβߤˬïۤ" );
}
void msg_read_leaflet(void){
    message("֡إ轻̱פȤʸ");
    message("٤ˤ⡢ΦΤ˸褦轻̱"
            "פĤ뤳ȤΤƤ롣"
            "Ǥˤϡ"
            "ޤ路Ѥο۷μ²⤬ꡢ"
            //            "ȤΤοΤΤȤϻפʤ̯д郎ڤ롣"
            "ΤΤɤʸˤ°ʤ̯д郎ڤ롣"
            "ߥȥ˥åؤˤǿȯĴ̤𤹤");
}
void msg_read_letter(void){
    message("ֵϤʤν񤫤줿ˡɤȻפޤ"
			"ɤꤵ줿ȤΤȡʤˤǤ"
		    "ϸͤʶʪǤꡢ"
			"̤ϸŪǤ礦"
			"ʤ񤫤줿褦"
			"ʳؤϤˡؤ򶯲С"
			"򳫤Ϥ뤫⤷ޤ"
			);
    /*
ơȼԤ顢褦
ʤˤǤ
ϤޤΤǤ뤳Ȥͤȡ
ʤ񤫤줿褦ˡʳؤϤˡؤ򶯲ΤɬפǤ礦
ֵưǤС
˥ꥸʥˡؤưƤ
ƿؤǸ˼ʸ򾧤ɬפ뤫Ȼפޤ
    */
}
void msg_read_secret_room_book(void){
//    message("ޤΤ 䤦 ĤˤΤ ʤܤ줤 Ȥ"
//    message("Mumanokiz lyau kizni nooka nakak boleily qrento"
//    message("दޤΤä 㤦 äĤ ̤ ʤä ܤ줤ꤤ Ȣ"
//    message("ʤˤ饪ȤᤤƤǤäѤ狼ʤ"
      message("ȤߤڡѤѤ᤯ȡƤս꤬ä");
/*
	message("ִΩĤΤΤԤˤϡ"
            "ŤȤ⤷ʲΤ"
            "ΰǤưʲ򾧤衣");
    message("ޤΤ   줤 Ȥ"
            "");
			*/
//    message("ޤΤ   줤 Ȥ");


//		ʲμʸƤ롣");
//	message("ιΤԤɤ餻褦Ȥ"

//		"μʸ϶ιΤԤɤ餻褦Ȥơ"
//			"۳ΤΤƤӽФƤޤä"
//			"ΤȤ");
	msg_recall_secret_room_book();
	message("ομʸʬ˿Ƥưɤ߼ʤ");
	message("ʸβˤϡĤΤ褦ʸͤƤ롣");
    //            message("ʸʬˤȤƤ롣");
}
void msg_recall_secret_room_book(void){
	message("ֶιΤ̵٤ν٤ˤϡ"
			"Ԥɤ餻褦Ȥ"
			"۳¸ߤƤӽФƤޤäȤ"
			"ŤȤ⤷ʲΤ"
			"ΰǤưʲμʸ򾧤뤳Ȥǡ"
			"δޤ路ԤԤȤ롣");
//    message("ޤΤ   줤 Ȥ");
//    message("दޤΤä 㤦 äĤ ̤ ʤä ܤ줤ꤤ Ȣ");
    message("दޤΤ     줤ꤤ Ȣ");
}
void msg_read_bathroom_2f_wall(void){
//    message("ʻǤʤˤ񤤤Ƥ롣"
	message("ξüȽɤǤʬϰʲΤ褦ɤ롣");
//    message("֤Τ 䤦 ĤˤΤ ʤܤ");
    message("֤Τä 㤦 äĤ ̤ ʤä ܤ줤");
//    message("ξüɤ߼ʤ");
}








void msg_read_boiler_room_wall(void){
	msg_recall_boiler_room_wall();
    message("국ϤǽäƤ롣");
}
void msg_recall_boiler_room_wall(void){
    message("ֲʤԼݤǤä"
            "˾ˡؤʤᡢ"
            "ϲˤƧΤ"
            "ޤͤˤʤȤϡ"
			"ãäƤ15ǯʾ夿"
			"̲֤ۤȻפäƤΤ"
			"Ƥˤˬ줿Ϣ椬"
			"ʹα¤ˤʤäƤ褦"
			"%w");
    message("\n"
			"ĴȤ轻̱ˤϡ"
            "̾񤤻ۼԤ˻Ť²¸ߤƤꡢ"
            "ˤϡ̱ߤƶαŪʿ¤򸫤Ȥ"
            "ϿĤäƤ롣"
			"%w");
    message("\n"
//			"Ǥӵä²Ρ"
//            "ȸƤ֤Τ⤪ޤۼԤ"
			"Ǥӵä²ޤ"
            "ޥɥʥɤƤӽФƤޤäΤǤС"
            "Τϡƿؤλųݤäο"
			"ڤ껥ϥꥪΥ٥ȤˤꡢΤȤϰ"
			"%w");
    message("\n"
			"֤ƿؤưϸΤ褦"
			"ξ㤷Ƥ褦ǻμˤ館ʤ"
			"ʤʤȤǤˡ"
			"ä顢ʤõƤߤ롣"
			"%w");
	message("\n"
			"ʤȤꡢˡؤ򸫤ĤƵưǤС"
			"ƿؤβǵΰ˼ʸ򾧤"
			"ۤԤ");
	message("ۤοϺ⤳γƤꡢ"
			"ԤƤ롣"
			"åȥǤꧤ"
			"ϰ줫Ȭ");
}

/*			
            "%w"
            );
		"%w");
*/



    /*
ƿؤβ


ƿؤѤϡꥸʥκŤʲΤ
ƿؤβμԤФǤơʸ򾧤ɬפ
    message("Ĵ٤Ȥ轻̱ˤϡ"
*/
    //    message("ֲʤԼݤǤä"





/*
ƿؤλųݤβˡ¸ߤϤ


    message("ܤƤߤȤ"
            "Τ˥ޥɥʥɻȼΤȤ򤷤Ƥ褦Ǥ"
            "ĤäƤˤϡѤ۳¸ߤ˴ؤ뵷ˤĤơ"
            "Ĥ䤬"
            "񤫤Ƥޤ");


ʤԼ





ŤΤ˰۷οפޤ路²ǤȤ⤬ꡢ





¤ͻҤ餹ȡŤǤ²ȿƤ¸ߤˡ
ޥɥʥɤΤͿƤޤä褦
ϤۤΤ۳ȤǤꡢ
Ȥȱƶ䤹äΤ
ʪĤǤ褦ˤʤäȤǡ
ŪϤ⶯줿褦

ˡؤֵưȤϸä
*/
/*
ΥϥեǤꡢʤºߤοʪʡȿȤ̵طǤ롣
H.P.եȤޥɥʥɤʤʪʸ̤ƤȤϿϤʤ

ޤȿˡԤäȤΤԤǤꡢ
ԤϷˡդȺƱƤȻפ롣

*/


void msg_touching_water(void){
    message("̤˼򿭤Фȡä夬ư褦˸");
    message("ְ㤤ȻפäΤȤ̤ޤ夬ꡢ"
            "ʤμ߹"
            "Ȥ夬Ӥ礤夬ꡢ"
            "ƨ֤ʤȤ߹ࡣ");
}
void msg_shadow_appeared(void){
	message("󤯤ǶڤΤ褦ʶӤ夬ꡢԤϭŤƤ벻롪");
}
void msg_shadow_behind_door(void){
	message("ΤˡԤΩäƤ뵤ۤ롣"
			"Τȩ롣");
}
void msg_shadow_in_room(void){
	message("⤬ͤĤͤλѤΤ褦ʹƤäƤ"
			"Ƥȯ䵤ǡΤĤ");
}
void msg_touching_shadow(void){
    message("ƤϤäȤ֤ܤꡢʤʤ蘆ä");
    message("볦ǤĤ졢"
            "ڤ褦ʴ˿Ȥޤ롣");
}
void msg_shadow_wandering(void){
	message("⤬ơԤäƤ褦"
			"⤭ޤ­ʹ"
			"ýڤη֤ΤĤ褦䵤Ǥ롣");
}
void msg_shadow_left(void){
	message("©Ƥȡ䤬­Фơϭ󤶤äƤä");
}

void msg_phone_call_started(void){
	message("äȤζäĤϤ᤿");
}
void msg_phone_call_continued(void){
	message("äϤޤĤ³Ƥ롣");
}
void msg_phone_call_stopped(void){
	message("äĤ");
}
void msg_answer_phone_call(void){
	message("ô򼪤Ƥȡ"
			"Ϥ˶褦ŪʹƤ");
	message("ϼᡢϻ");
	message("줭äϤȤ⤹Ȥʤʤä");
}
void msg_clock_adjusting_guide(void){
    message("(0715פΤ褦˿4Ƥ꥿󥭡)");
}
void msg_clock_door_opened(void){
	message("ɤλפĤ"
	  	    "ʸפξξ뤫ʤˤӽФƤ");
}
void msg_clock_door_closed(void){
	message("פĤ꽪ꡢ뤬Ĥ");
}

void msg_attacked_on_2f(void){
    message("󳬤­Ƨ줿Ȥ󡢻볦ðŤˤʤä");
    message("Τդ褦䵤ޤ졢ưȤǤʤ");
    message("ʤΰռϤΤޤڤ줿ġ");
}
void msg_moved_on_2f(void){
    message("ĤȡΤˤ"
            "ɤä褦");
}

void msg_armor_moving(void){
    message("㥬ȲΩƤơŤƤ롣");
}
void msg_armor_appeared(void){
    message("ܤˡ򹽤줿!");
}
void msg_killed_by_armor(void){
    message("̵򿶤겼ʤϿĤˤʤä");
}
void msg_exiting_window(void){
    message("˽Ф褦뤫ȤФȤ"
            "褯ƤȤʤοΤ򿿤Ĥˤ");
}
void msg_feeling_magic_circle_power(void){
    message("ΤˡΤԻ׵ĤϤ򴶤롣");
}
void msg_looking_pocket_notebook(void){
    message("%nn˵ˤ%nlƤ롣",
            ni_skeleton, ni_pocket_notebook);
}
void msg_no_light(void){
    message("ðŤǲ⸫ʤ"
            "򸫤ĤƤ褵");
}




    /*
    message("ȤȤΤ륵纴"
            "γ˾ۤĴ˽Фޤ"
            "äƤʤȤȽ"
            "Ʊۤ1932ǯˡ"
            "ٹΥޥɥʥɻ᤬ʤܤΤ˷ƤΤǡ"
            "׿»˻᤬"
            "1990ǯˤϵｻ԰Ȥʤɤ"
            "줿ۤȸƤФƤ롣"
            "ٹκα"
            "äԤïⵢäƤʤͩߤȤơ"
            "ϸǤ϶Ƥ");
*/
